; Simple installer for exiftool
;
; To be compiled with NSIS (Nullsoft Scriptable Install System http://nsis.sourceforge.net/

!define MYSRCDIR "C:\temp\Image-ExifTool-11.42" ; better pass this to makensis.exe

!include "FileFunc.nsh" ; for ${DirState}
!include LogicLib.nsh

Unicode True ; is this really needed or just the default?

VIAddVersionKey /LANG=0 "ProductName" "ExifTool"
;VIAddVersionKey /LANG=0 "LegalCopyright" "tbd"
VIAddVersionKey /LANG=0 "FileDescription" "ExifTool installer"
;VIAddVersionKey /LANG=0 "FileVersion" "1.2.3xy" ; pass it to makensis
VIProductVersion 0.0.0.0

; The name of the installer
Name "Install ExifTool"

OutFile "exiftool_install.exe"

; Not exactly beautiful, but Google Chrome installs also to %LOCALAPPDATA%
InstallDir $LOCALAPPDATA\ExifTool

;ComponentText "couldn't do better than the default text"

; Request application privileges for Windows Vista and later
RequestExecutionLevel user

;--------------------------------
; Pages

;Page license ; licenses are usually boring

Page components ; select the components to be installed

Page directory "" "" DirLeave ; Ask where to install. Set leave handler for checks

Page instfiles ; do the install

UninstPage uninstConfirm
UninstPage instfiles

;--------------------------------
Function DirLeave
  StrCpy $R0 $INSTDIR "" -2
  StrCmp $R0 ":\" baddir
  StrCmp $INSTDIR $WINDIR baddir
  StrCmp $INSTDIR $SYSDIR baddir nobaddir
  baddir:
  MessageBox MB_YESNO `"$INSTDIR" is not recommended, install anyway?` IDYES nobaddir
  Abort
  nobaddir:

  ; check whether the install directory is empty and show a warning if not
  ${DirState} "$INSTDIR" $R0 ; $R0="1" (directory is full)
  ${If} $R0 = 1
    MessageBox MB_YESNO `"$INSTDIR" is not empty, install anyway?` IDYES instanyway
    Abort
    instanyway:
  ${EndIf}

FunctionEnd
;--------------------------------

; The stuff to install
Section "Exiftool"
  SectionIn RO ; can't be unchecked

  SetOutPath $INSTDIR ; output path (where to put files)

  File    ${MYSRCDIR}\exiftool.exe
  File    ${MYSRCDIR}\exiftool.pl
  File    ${MYSRCDIR}\*.dll
  File /r ${MYSRCDIR}\lib
SectionEnd ; end the section

Section /o "Help and support files"
  SetOutPath $INSTDIR
  File /r ${MYSRCDIR}\arg_files
  File /r ${MYSRCDIR}\config_files
  File /r ${MYSRCDIR}\fmt_files
  File /r ${MYSRCDIR}\html
SectionEnd ; end the section

Section /o "Plain perl.exe" ; maybe not that important for normal users
  SetOutPath $INSTDIR
  File /oname=perl.exe ${MYSRCDIR}\exiftool.exe
SectionEnd ; end the section

Section /o "Selftest (needs perl.exe)" ; likely not needed by most users
  SetOutPath $INSTDIR
  File ${MYSRCDIR}\selftest.pl
  File /r /x *.tmp ${MYSRCDIR}\t
SectionEnd ; end the section

Section "Create Uninstaller"
  WriteUninstaller $INSTDIR\uninst-exiftool.exe
SectionEnd ; end the section

Section "Add to Path (current user)"
  EnVar::AddValue "Path" $INSTDIR
  DetailPrint "Added $INSTDIR to path"
SectionEnd ; end the section

Section "Uninstall"
  Delete $INSTDIR\uninst-exiftool.exe ; delete self (uses a helper in %temp%)
  Delete $INSTDIR\perl.exe
  Delete $INSTDIR\exiftool.exe
  Delete $INSTDIR\exiftool.pl
  Delete $INSTDIR\selftest.pl
  Delete $INSTDIR\perl*.dll
  Delete $INSTDIR\README
  Delete $INSTDIR\perl-Image-ExifTool.spec
  RMDir /r $INSTDIR\lib
  RMDir /r $INSTDIR\t
  RMDir /r $INSTDIR\arg_files
  RMDir /r $INSTDIR\config_files
  RMDir /r $INSTDIR\fmt_files
  RMDir /r $INSTDIR\html
  RMDir $INSTDIR ; will be deleted only if empty
  EnVar::DeleteValue "Path" $INSTDIR
  DetailPrint "Removed $INSTDIR from path"
SectionEnd
